Creates a custom field definition.

POSThttps://api.awork.com/api/v1/customfielddefinitions
POST https://api.awork.com/api/v1/customfielddefinitions

Creates a custom field definition that can be linked to project templates, projects, or tasks according to its entity type.

Authentication

AuthorizationBearer

Send your token in the Authorization: Bearer <token> header. See Authentication for API keys and OAuth.

Request body Required

The model containing the details for creating a new custom field definition.

application/json

namestringRequired
minLength: 1 maxLength: 255

The name of the custom field definition.

typestringRequired

Allowed: "text" "number" "date" "datetime" "select" "coloredSelect" "link" "boolean" "user" "client"

minLength: 1

The type of the custom field definition.

selectionOptionsarray of object or nullOptional

The selection options for the custom field definition. Can only be used if the type is 'select'.

Show 3 properties
valuestringRequired
minLength: 1 maxLength: 255

The selection value which can be used in a select custom field.

colorstring or nullOptional

Allowed: "red" "orange" "yellow" "green" "cyan" "blue" "indigo" "purple" "steel"

The color of the selection option.

ordernumberRequired
format: double

The order of the custom field selection option.

ordernumber or nullOptional
format: double

The order of the custom field definition. This value is only used (and required) if the entity is 'project', as the project custom field definitions are globally ordered. To set the order for task custom field definitions, use the endpoint to update the order of a custom field definition for a project/project template.

entitystringRequired

Allowed: "task" "project"

minLength: 1

The entity the custom field definition can be linked to.

Responses

200 OK

application/json

idstringOptional
format: uuid

The id of the custom field definition.

namestring or nullOptional

The name of the custom field definition.

entitystringOptional

Allowed: "task" "project"

The entity the custom field definition can be linked to.

typestringOptional

Allowed: "text" "number" "date" "datetime" "select" "coloredSelect" "link" "boolean" "user" "client"

The type of the custom field definition.

createdOnstringOptional
format: date-time

The date this entity was created.

createdBystringOptional
format: uuid

The id of the user who created this entity.

updatedOnstringOptional
format: date-time

The date this entity was last modified.

updatedBystringOptional
format: uuid

The id of the user who last modified this entity.

ordernumber or nullOptional
format: double

If it's a project custom field, it's the global order of the custom field definition. Otherwise, it's the order of the custom field definition within a project template or a project.

isExternalbooleanOptional

True if this entity is coming from an external workspace (awork Connect).

selectionOptionsarray of object or nullOptional

The selection options for this custom field definition.

Show 4 properties
idstringOptional
format: uuid

The id of the custom field selection option.

valuestringRequired
minLength: 1

The selection value which can be later used in a select custom field.

colorstring or nullOptional

Allowed: "red" "orange" "yellow" "green" "cyan" "blue" "indigo" "purple" "steel"

The color of the selection option.

ordernumberOptional
format: double

The order of the custom field selection option.

400 Bad Request

application/json

codestringRequired
minLength: 1

The error code.

descriptionstringRequired
minLength: 1

The description of the error.

linkstringRequired
minLength: 1

The link to the API documentation page.

detailsarray of string or nullOptional

A list of details describing the error.

validationErrorsarray of object or nullOptional

If a validation error occurred, this contains the validation errors for each property.

Show 2 properties
propertystring or nullOptional

The name of the property that failed validation.

messagestring or nullOptional

The reason why this property failed validation.

traceIdstring or nullOptional

The request trace id for tracking the request.

Search documentation